
package configurationHandling;

/**
 * <p></p>
 * 
 */
public class Eccezione extends Exception {

    private String descrizione;

/**
 * <p>Costruttore di default</p>
 * 
 */
    public  Eccezione() {        
        super();
    } 

/**
 * <p>Costruttore avente come arametro il codice dell'errore, da cui viene ricavata la descrizione.</p>
 * 
 * @param p_message il codice dell'errore
 */
    public  Eccezione(String p_message) {
        super(p_message);
        descrizione = getDescrizioneErrore(p_message);
    } 

/**
 * <p>Restituisce la descrizione dell'errore.</p>
 * 
 * @return la descrizione dell'errore
 */
    public String getDescrizione() {        
        return descrizione;
    } 
  
/**
 * <p>Restituisce il messaggio di errore relativo al codice passato.</p>
 * 
 * 
 * @param p_message codice di errore
 * @return la stringa contenente la descrizione dell'errore.
 */    
    private String getDescrizioneErrore(String p_message){
        String descrizione = "operazione non eseguita";

        if (p_message == "ERR_DB")
            descrizione = "impossibile accedere al DB";        
        if (p_message == "ERR_LOGIN")
            descrizione = "username o password non validi";        
        if (p_message == "ERR_CREADIR")
            descrizione = "impossibile creare la cartella dei documenti relativi all'immobile";         
        if (p_message == "ERR_GETDIR")
            descrizione = "impossibile accedere alla cartella dei documenti relativi all'immobile";                 
        if (p_message == "ERR_ELDIR")
            descrizione = "impossibile eliminare la cartella dei documenti relativi all'immobile";                 
        if (p_message == "ERR_INSIMMOBILE")
            descrizione = "immobile non inserito";
        if (p_message == "ERR_MODIMMOBILE")
            descrizione = "immobile non modificato";
        if (p_message == "ERR_ELIMMOBILE")
            descrizione = "immobile non eliminato";        
        if (p_message == "ERR_INSRENDERING")
            descrizione = "immagine non inserita";
        if (p_message == "ERR_MODRENDERING")
            descrizione = "immagine non modificata";
        if (p_message == "ERR_ELRENDERING")
            descrizione = "immagine non eliminata";
        if (p_message == "ERR_INSDOCUMENTO")
            descrizione = "documento non inserito";
        if (p_message == "ERR_MODDOCUMENTO")
            descrizione = "documento non modificato";
        if (p_message == "ERR_ELDOCUMENTO")
            descrizione = "documento non eliminato";        
        if (p_message == "ERR_SALVADOCUMENTO")
            descrizione = "impossibile salvare il documento";                
        if (p_message == "ERR_SETLOG")
            descrizione = "impossibile scrivere log";                
        if (p_message == "ERR_SETINI")
            descrizione = "parametri di configurazione non impostati";
        if (p_message == "ERR_INVIAMAIL")
            descrizione = "impossibile inviare mail";
        if (p_message == "ERR_SESSION")
            descrizione = "sessione non valida";                 
        if (p_message == "ERR_GETPARSETUP")
            descrizione = "impossibile leggere parametro di setup";                 
        
        return "Errore: " + descrizione;
    }    
}
