// dichiarazione di appartenenza al package
package entityLib;

/**
 * Persona, classe struttura che definisce l'entita' business Persona
 * Creation date: (18/10/2002 12.33.01)
 * @author: Giulio Destri
 */
public class Persona {
    
    /**
     * Attributi interni della classe: nome, cognone, numero telefonico
     * Creation date: (18/10/2002 12.39.29)
     */
    private String nome;
    private String cognome;
    private String numtel;

    /**
     * Costruttore vuoto, lascia a null gli attributi
     * Creation date: (18/10/2002 12.39.29)
     */
    public Persona() {
        super();
    } // end costruttore vuoto

   /**
    * Costruttore che inizializza gli attributi ai valori passati come parametro
    * Creation date: (18/10/2002 12.39.29)
    * @param p_nome java.lang.String
    * @param p_cognome java.lang.String
    * @param p_numtel java.lang.String
    */
    public Persona(String p_nome, String p_cognome, String p_numtel) {
	super();
        // l'oggetto String in Java e' l'unico che viene passato
        // per copia e non per reference
	nome = p_nome;
	cognome = p_cognome;
	numtel =  p_numtel;
    } // end costruttore pieno

   /**
    * Metodo per leggere il cognome
    * Creation date: (18/10/2002 12.34.42)
    * @return java.lang.String
    */
    public java.lang.String getCognome() {
	return cognome;
    } // end getCognome

    /**
     * Metodo per leggere il nome
     * Creation date: (18/10/2002 12.34.00)
     * @return java.lang.String
     */
    public String getNome() {
	return nome;
    } // end getNome
    
    /**
     * Metodo per leggere il num tel
     * Creation date: (18/10/2002 12.35.03)
     * @return java.lang.String
     */
    public java.lang.String getNumtel() {
	return numtel;
    } // end getNumtel
    
    /** 
     * Metodo per impostare il valore del cognome
     * Creation date: (18/10/2002 12.34.42) 
     * @param p_cognome java.lang.String
     */
    public void setCognome(String p_cognome) {
	cognome = p_cognome;
    } // end setCognome
    
    /**
     * Metodo per impostare il valore del nome
     * Creation date: (18/10/2002 12.34.00)
     * @param p_nome java.lang.String
     */
    public void setNome(String p_nome) {
	nome = p_nome;
    } // end setNome 
    
    /**
     * Metodo per impostare il valore del num tel
     * Creation date: (18/10/2002 12.35.03)
     * @param newNumtel java.lang.String
     */
    public void setNumtel(String p_numtel) {
	numtel = p_numtel;
    } // end setNumtel
    
    /** 
     * Metodo per visualizzare il contenuto di Persona in
     * un'unica stringa
     * Sovrascrive (overriding) il metodo toString di Object
     * Creation date: (18/10/2002 12.44.31)
     * @return java.lang.String
     */
    public String toString() {
	String risultato;
        // sintassi di inizializzazione con composizione
	risultato="Nome = " + nome + "\tCognome = " + cognome + "\ttel.  " + numtel;
	return risultato;
    } // end toString

    /** 
     * Metodo per impostare tutti gli attributi di Persona in
     * un sol colpo
     * Creation date: (18/10/2002 12.44.31)
     * @param p_nome java.lang.String
     * @param p_cognome java.lang.String
     * @param p_numtel java.lang.String
     */
    public void setValues(String p_nome, String p_cognome, String p_numtel) {
        // l'oggetto String in Java e' l'unico che viene passato
        // per copia e non per reference
	nome = p_nome;
	cognome = p_cognome;
	numtel =  p_numtel;
    } // end setValues
    
} // end class Persona
