// dichiarazione di appartenenza al package
package exceptionLib;

/**
 * RubricaException: eccezione caratteristica per il GestoreRubrica
 * Creation date: (30/10/2002 11.22.54)
 * @author: Giulio Destri
 */
public class RubricaException extends Exception {
    /**
     * Attributo interno della classe: messaggio, per portare 
     * il messaggo di errore come una stringa
     * Creation date: (30/10/2002 12.39.29)
     */
    private String messaggio;
    private int tipo;
    
    public static final int SQL_INSERT = 1;
    public static final int SQL_DELETE = 2;
    public static final int SQL_UPDATE = 3;
    public static final int SQL_SELECT = 4;
    public static final int NOT_FOUND = 5;
    
    /**
     * Costruttore vuoto, lascia messaggio = null
     */
    public RubricaException() {
        super();
    } // end costruttore vuoto
     
    /** Creates a new instance of RubricaException */
    public RubricaException(String p_messaggio, int p_tipo) {
        messaggio = p_messaggio;
        tipo = p_tipo;
    }
    
    /**
     * Costruttore che imposta
     * @param s java.lang.String
     */
    public RubricaException(String s) {
	super(s);
    } // end costruttore che imposta
    
    /**
     * Metodo per leggere il messaggio
     * Creation date: (30/10/2002 11.25.01)
     * @return java.lang.String
     */
    public String getMessaggio() {
	return messaggio;
    } // end getMessaggio
    
    /**
     * Metodo per impostare il messaggio
     * Creation date: (30/10/2002 11.25.01)
     * @param p_messaggio java.lang.String
     */
    public void setMessaggio(String p_messaggio) {
	messaggio = p_messaggio;
    } // end setMessaggio
    
} // end class RubricaException
