/*
 * EditorFileHandler.java
 *
 * Created on 24 giugno 2003, 16.36
 */

package myeditor;

import java.io.*;
/**
 *
 * @author  Giulio Destri
 */
public class EditorFileHandler {
    
    //
    /** Creates a new instance of EditorFileHandler */
    public EditorFileHandler() {
    } // end costruttore
     
    /**
     * caricaStringaDaFile: carica una stringa da file ASCII
     * Creation date: (30/10/2002 16.40.22)
     * @param p_filename java.lang.String
     * @returns java.lang.String
     */
    public String caricaStringaDaFile(String p_filename) {
        // file da aprire
        FileInputStream fin=null;
        
        // numero di byte del file
        int fileSize = 0;
        
        // Stringa risultante
        String res = null;
        
	try {
            
            // apre il file in lettura
            fin = new FileInputStream(p_filename);
            
            // controlla la dimensione del file
            fileSize = fin.available();
            
            // trasforma la stringa in un array di byte (compatibile ASCII)
            byte b[]= new byte[fileSize];
            
            // legge nell'array i byte dal file
	    fin.read(b);
                
            // chiude il file
            fin.close();
            
            // riempie la stringa di caratteri
            res = new String(b);
            
        // gestione delle varie eccezioni possibili con i file
	} catch(FileNotFoundException e) {
		System.err.println("File Not Found!");
	} catch(IOException e) {
		System.err.println("I/Oerr");
	} catch(IllegalArgumentException e) {
		System.err.println ("java FileCopy srcdest");
	} finally {
		try {
                    // in caso di problemi tenta di chiudere comunque il file
                    if (fin!=null) fin.close();
		} catch(IOException e) {
                    System.err.println("I/O err");
		}
	}
        
        // se la stringa e' ancora null (errore di lettura dal file)
        // viene allocata come stringa vuota
        if (res == null) {
            res = new String("");
        }
        
        // restituisce la stringa
        return res;
    } // end caricaStringaDaFile
    
    
    /**
     * salvaStringaSuFile: salva una stringa su file
     * Creation date: (30/10/2002 16.40.22)
     * @param p_filename java.lang.String
     * @param p_testo java.lang.String
     */
    public void salvaStringaSuFile(String p_filename, String p_testo) {
        // file da aprire
        FileOutputStream fout=null;

	try {
            
            // apre il file in scrittura
            fout = new FileOutputStream(p_filename);
            
            // trasforma la stringa in un array di byte (compatibile ASCII)
            byte b[]=p_testo.getBytes();
                
            // scrive l'array nel file
	    fout.write(b);
                
            // chiude il file
            fout.close();
            
        // gestione delle varie eccezioni possibili con i file
	} catch(FileNotFoundException e) {
		System.err.println("File Not Found!");
	} catch(IOException e) {
		System.err.println("I/Oerr");
	} catch(IllegalArgumentException e) {
		System.err.println ("java FileCopy srcdest");
	} finally {
		try {
                    // in caso di problemi tenta di chiudere comunque il file
                    if (fout != null) fout.close();
		} catch(IOException e) {
                    System.err.println("I/O err");
		}
	}
    } // end salvaStringaSuFile
    
} // end class EditorFileHandler
