/*
 * GuiEditor.java
 *
 * Created on 6 aprile 2003, 0.40
 */

package myeditor;

import java.awt.FileDialog;
import java.awt.Dialog;

/**
 *
 * @author  Giulio Destri
 */
public class GuiEditor extends java.awt.Frame {
    
    // attributo editorFileHandler (per agire sui file)
    EditorFileHandler a_fileHandler; 
    
    // attributo nome del file correntemente attivo
    String a_mainFileName = new String("Senza Nome");
      
    // attributo per la clipboard
    EditorClipboard a_editorClipboard;
    
    /** Creates new form GuiEditor */
    public GuiEditor() {
        initComponents();
        a_fileHandler = new EditorFileHandler();
        a_editorClipboard = new EditorClipboard();
        setSize(410,330);
        this.setTitle("JavaEditor: " + a_mainFileName);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        mainTextArea = new java.awt.TextArea();
        FileMenuBar = new java.awt.MenuBar();
        fileMenu = new java.awt.Menu();
        newMenuItem = new java.awt.MenuItem();
        openMenuItem = new java.awt.MenuItem();
        saveMenuItem = new java.awt.MenuItem();
        saveAsMenuItem = new java.awt.MenuItem();
        exitMenuItem = new java.awt.MenuItem();
        editMenu = new java.awt.Menu();
        clearMenuItem = new java.awt.MenuItem();
        copyMenuItem = new java.awt.MenuItem();
        cutMenuItem = new java.awt.MenuItem();
        pasteMenuItem = new java.awt.MenuItem();
        helpMenu = new java.awt.Menu();
        aboutMenuItem = new java.awt.MenuItem();

        setLayout(null);

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        add(mainTextArea);
        mainTextArea.setBounds(10, 70, 390, 240);

        fileMenu.setLabel("File");
        newMenuItem.setLabel("New");
        newMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(newMenuItem);
        openMenuItem.setLabel("Open");
        openMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(openMenuItem);
        saveMenuItem.setLabel("Save");
        saveMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(saveMenuItem);
        saveAsMenuItem.setLabel("Save As...");
        saveAsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveAsMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(saveAsMenuItem);
        fileMenu.addSeparator();
        exitMenuItem.setLabel("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(exitMenuItem);
        FileMenuBar.add(fileMenu);
        editMenu.setLabel("Edit");
        clearMenuItem.setLabel("Clear All");
        clearMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearMenuItemActionPerformed(evt);
            }
        });

        editMenu.add(clearMenuItem);
        copyMenuItem.setLabel("Copy");
        copyMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                copyMenuItemActionPerformed(evt);
            }
        });

        editMenu.add(copyMenuItem);
        cutMenuItem.setLabel("Cut");
        cutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cutMenuItemActionPerformed(evt);
            }
        });

        editMenu.add(cutMenuItem);
        pasteMenuItem.setLabel("Paste");
        pasteMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pasteMenuItemActionPerformed(evt);
            }
        });

        editMenu.add(pasteMenuItem);
        FileMenuBar.add(editMenu);
        helpMenu.setLabel("Help");
        aboutMenuItem.setLabel("About");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });

        helpMenu.add(aboutMenuItem);
        FileMenuBar.add(helpMenu);
        setMenuBar(FileMenuBar);

        pack();
    }//GEN-END:initComponents

    private void pasteMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pasteMenuItemActionPerformed
        // Add your handling code here:
        incollaTesto();
    }//GEN-LAST:event_pasteMenuItemActionPerformed

    private void cutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cutMenuItemActionPerformed
        // Add your handling code here:
        tagliaTesto();
    }//GEN-LAST:event_cutMenuItemActionPerformed

    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        // Add your handling code here:
        this.dispose();
    }//GEN-LAST:event_exitMenuItemActionPerformed

    private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
        // Add your handling code here:
        mostraAbout();
    }//GEN-LAST:event_aboutMenuItemActionPerformed

    private void clearMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearMenuItemActionPerformed
        // Add your handling code here:
        mainTextArea.setText("");
    }//GEN-LAST:event_clearMenuItemActionPerformed

    private void copyMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_copyMenuItemActionPerformed
        // Add your handling code here:
        copiaTesto();
    }//GEN-LAST:event_copyMenuItemActionPerformed

    private void saveAsMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveAsMenuItemActionPerformed
        // Add your handling code here:
        salvataggioFileConNome();
    }//GEN-LAST:event_saveAsMenuItemActionPerformed

    private void saveMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveMenuItemActionPerformed
        // Add your handling code here:
        salvataggioFile();
    }//GEN-LAST:event_saveMenuItemActionPerformed

    private void newMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newMenuItemActionPerformed
        // Add your handling code here:
        nuovoFile();
    }//GEN-LAST:event_newMenuItemActionPerformed

    private void openMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openMenuItemActionPerformed
        // Add your handling code here:
        aperturaFile();
    }//GEN-LAST:event_openMenuItemActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

/*************************************************************************/
/* metodi aggiunti da utente per svolgere le operazioni */
/************************************************************************/    
    /**
     * nuovoFile: gestisce le azioni corrispondenti all'evento "new"
     * Creation date: (30/10/2002 16.40.22)
     */ 
    void nuovoFile() {
        
        a_mainFileName = "Senza nome";
        
        // apre il main file e lo carica nella mainTextArea
        mainTextArea.setText("");
           
        // imposta il titolo della finestra principale
        this.setTitle("JavaEditor: " + a_mainFileName);
                
    } // end nuovoFile
    
    /**
     * aperturaFile: gestisce l'apertura del file corrispondente all'evento "open"
     * Creation date: (30/10/2002 16.40.22)
     */ 
    void aperturaFile() {
        // definisce il filedialog (finestra per l'accesso ai file)
        FileDialog fd;
        String fileName;
        String folderName;
        
        // crea il fileDialog
        fd = new FileDialog(this, "File Load", FileDialog.LOAD);
        fd.show();
        
        // definisce il main file in base alla scelta dell'utente
        fileName = fd.getFile();
        folderName = fd.getDirectory();
        System.out.println(fileName);
        System.out.println(folderName);
        
        a_mainFileName = folderName + fileName;
        System.out.println(a_mainFileName);
        
        // apre il main file e lo carica nella mainTextArea
        mainTextArea.setText(a_fileHandler.caricaStringaDaFile(a_mainFileName));
        
        // chiude la finestra del filedialog
        fd.dispose();
        
        // imposta il titolo della finestra principale
        this.setTitle("JavaEditor: " + a_mainFileName);
                
    } // end aperturaFile

    /**
     * salvataggioFile: gestisce l'apertura del file corrispondente all'evento "save"
     * Creation date: (30/10/2002 16.40.22)
     */ 
    void salvataggioFile() {
                
        // apre il main file e lo carica nella mainTextArea
        a_fileHandler.salvaStringaSuFile(a_mainFileName,mainTextArea.getText());
             
    } // end salvataggioFile
    
    
    /**
     * salvataggioFileConNome: gestisce l'apertura del file corrispondente all'evento "save as..."
     * Creation date: (30/10/2002 16.40.22)
     */ 
    void salvataggioFileConNome() {
        // definisce il filedialog (finestra per l'accesso ai file)
        FileDialog fd;
        String fileName;
        String folderName;
        
        // crea il fileDialog
        fd = new FileDialog(this, "File Save", FileDialog.SAVE);
        fd.show();
        
        // definisce il main file in base alla scelta dell'utente
        fileName = fd.getFile();
        folderName = fd.getDirectory();
        a_mainFileName = folderName + fileName;
                
        // apre il main file e lo carica nella mainTextArea
        a_fileHandler.salvaStringaSuFile(a_mainFileName,mainTextArea.getText());
        
        // chiude la finestra del filedialog
        fd.dispose();

        // imposta il titolo della finestra principale
        this.setTitle("JavaEditor: " + a_mainFileName);
    } // end salvataggioFileConNome

   /**
     * copiaTesto: gestisce la copia del testo corrispondente all'evento "copy"
     * Creation date: (30/10/2002 16.40.22)
     */ 
    void copiaTesto() {
        
        // stringa per il buffer
        String localBuf;
        
        localBuf = mainTextArea.getSelectedText();
        System.out.println(localBuf);
        a_editorClipboard.insertString(localBuf);
           
    } // end copiaTesto
    
   /**
     * tagliaTesto: gestisce lo spostamento del testo corrispondente all'evento "cut"
     * Creation date: (30/10/2002 16.40.22)
     */ 
    void tagliaTesto() {
        
        // stringa per il buffer
        String localBuf;
        
        // inizio e fine della selezione
        int inizio = mainTextArea.getSelectionStart();
        int fine = mainTextArea.getSelectionEnd();
        
        // copia il testo selezionato
        localBuf = mainTextArea.getSelectedText();
        System.out.println(localBuf);
        a_editorClipboard.insertString(localBuf);
        
        // rimuove il testo selezionato
        mainTextArea.replaceRange("", inizio, fine);
    } // end tagliaTesto
    
    /**
     * incollaTesto: gestisce la copia del testo corrispondente all'evento "paste"
     * Creation date: (30/10/2002 16.40.22)
     */ 
    void incollaTesto() {
        
        // stringa per il buffer
        String localBuf;
        
        localBuf = a_editorClipboard.extractString();
        
        // posizione del cursore
        int posCursore = mainTextArea.getCaretPosition();
        
        // inizio e fine della selezione
        int inizio = mainTextArea.getSelectionStart();
        int fine = mainTextArea.getSelectionEnd();
        
        if (inizio == fine) {
            // non c'e' testo selezionato
            mainTextArea.replaceRange(localBuf, posCursore, posCursore);
        } else {
            mainTextArea.replaceRange(localBuf, inizio, fine);
        }
        System.out.println(localBuf);
                   
    } // end incollaTesto
       
    /**
     * mostraAbout: gestisce l'apertura del dialogBox corrispondente all'evento "About"
     * Creation date: (30/10/2002 16.40.22)
     */ 
    void mostraAbout() {
        // definisce il dialog (finestrella per mostrare qualcosa)
        Dialog ad;
        String name = " Java Editor";
        String author = "Written by Giulio Destri";
        String copyright = "(C) AreaSP 2002";
                
        // crea il DialogBox, modale
        ad = new AboutBox(this, true, "About Java Editor", name, author, copyright);
        ad.show();
        
    } // end mostraAbout

    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new GuiEditor().show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.MenuItem newMenuItem;
    private java.awt.TextArea mainTextArea;
    private java.awt.Menu fileMenu;
    private java.awt.MenuItem exitMenuItem;
    private java.awt.MenuItem saveAsMenuItem;
    private java.awt.MenuItem saveMenuItem;
    private java.awt.MenuItem copyMenuItem;
    private java.awt.MenuItem pasteMenuItem;
    private java.awt.MenuItem cutMenuItem;
    private java.awt.MenuItem openMenuItem;
    private java.awt.Menu editMenu;
    private java.awt.MenuBar FileMenuBar;
    private java.awt.MenuItem clearMenuItem;
    private java.awt.MenuItem aboutMenuItem;
    private java.awt.Menu helpMenu;
    // End of variables declaration//GEN-END:variables
    
}
