// dichiarazione di appartnenenza al package
package rubricaLib;

// importazione del package di libreria java.io e java.util
import java.io.*;
import java.util.*;

// importazione degli altri package realizzati con le classi usate
import exceptionLib.RubricaException;
import entityLib.Persona;


/**
 * GestoreRubrica: classe di servizio che svolge i compiti della rubrica
 * Creation date: (25/10/2002 10.37.18)
 * @author: Giulio Destri
 */
public class GestoreRubrica {
    /**
     * Attributo interno della classe: listaPersone, la lista delle persone
     * Creation date: (25/10/2002 12.39.29)
     */
    private Vector listaPersone;
	
    /**
    * Costruttore, istanzia il Vector ma lo lascia vuoto
    */
    public GestoreRubrica() {
	super();
	listaPersone=new Vector();
	popolaLista();
    } // end costruttore
    
    /**
     * cercaPerCognome: restituisce la Persona in base al cognome
     * Creation date: (25/10/2002 10.46.52)
     * @return RubricaPkg.Persona
     * @param p_cognome java.lang.String 
     */
    public Persona cercaPerCognome(String p_cognome) throws RubricaException {
        
        // Persona da ritornare
	Persona res=null;
        
        // Persona usata per il test di ricerca
	Persona temporaneo;
        
        // calcolo del numero di persone presenti nella lista
	int numPersone=listaPersone.size();
        
        // ricerca interna alla lista
	for (int i=0; i<numPersone;i++) { 
            
            // l'elemento temporaneo e' quello corrente del ciclo
            // deve essere "castizzato" a Persona essendo un Object
            temporaneo=(Persona) listaPersone.elementAt(i);
            System.out.println("Chiave cognome = "+p_cognome);
            System.out.println("Cognome ottenuto = "+temporaneo.getCognome());
            
            // se l'elemento ha lo stesso cognome
            if (temporaneo.getCognome().equals(p_cognome)) { 
                System.out.println("EST EQUAL");
                
                // viene copiato come risultato
                res=temporaneo; 
                
                // e si esce dal ciclo (solo il primo elemento e' trovato)
                break;
            } // end if
	} // end for
        
        // se il risultato e' ancora null
	if (res==null){
            // viene lanciata un'eccezione
            RubricaException errore=new RubricaException();
            errore.setMessaggio("Nessun elemento trovato");
            throw errore;
	
	} // end if (res==null)
        
        // ritorna il risultato
        return res;
    } // end cercaPerCognome

    
    
    /**
     * cercaPerNome: restituisce la Persona in base al nome
     * Creation date: (25/10/2002 10.46.52)
     * @return RubricaPkg.Persona
     * @param p_nome java.lang.String 
     */
    public Persona cercaPerNome(String p_nome) throws RubricaException {
        
        // Persona da ritornare
	Persona res=null;
        
        // Persona usata per il test di ricerca
	Persona temporaneo;
        
        // calcolo del numero di persone presenti nella lista
	int numPersone=listaPersone.size();
        
        // ricerca interna alla lista
	for (int i=0; i<numPersone;i++) { 
            
            // l'elemento temporaneo e' quello corrente del ciclo
            // deve essere "castizzato" a Persona essendo un Object            
            temporaneo=(Persona) listaPersone.elementAt(i);
            System.out.println("Chiave nome = "+p_nome);
            System.out.println("Cognome ottenuto = "+temporaneo.getNome());
            
            // se l'elemento ha lo stesso nome
            if (p_nome.equals(temporaneo.getNome())) { 
                System.out.println("EST EQUAL");
                
                // viene copiato come risultato
                res=temporaneo; 
                
                // e si esce dal ciclo (solo il primo elemento e' trovato)
                break;
            } // end if
	} // end for
        
        // se il risultato e' ancora null
	if (res==null){
            // viene lanciata un'eccezione
            RubricaException errore=new RubricaException();
            errore.setMessaggio("Nessun elemento trovato");
            throw errore;
	
	} // end if (res==null)
        
        // ritorna il risultato
        return res;
    } // end cercaPerNome

    /**
     * cercaPerNome: restituisce la Persona in base al numtel
     * Creation date: (25/10/2002 10.46.52)
     * @return RubricaPkg.Persona
     * @param p_numtel java.lang.String 
     */
    public Persona cercaPerNumtel(String p_numtel) throws RubricaException {
        
        // Persona da ritornare
	Persona res=null;
        
        // Persona usata per il test di ricerca
	Persona temporaneo;
        
        // calcolo del numero di persone presenti nella lista
	int numPersone=listaPersone.size();
        
        // ricerca interna alla lista
	for (int i=0; i<numPersone;i++) { 
            
            // l'elemento temporaneo e' quello corrente del ciclo
            // deve essere "castizzato" a Persona essendo un Object            
            temporaneo=(Persona) listaPersone.elementAt(i);
            System.out.println("Chiave numtel = "+p_numtel);
            System.out.println("Numtel ottenuto = "+temporaneo.getNumtel());
            
            // se l'elemento ha lo stesso nome
            if (p_numtel.equals(temporaneo.getNumtel())) { 
                System.out.println("EST EQUAL");
                
                // viene copiato come risultato
                res=temporaneo; 
                
                // e si esce dal ciclo (solo il primo elemento e' trovato)
                break;
            } // end if
	} // end for
        
        // se il risultato e' ancora null
	if (res==null){
            // viene lanciata un'eccezione
            RubricaException errore=new RubricaException();
            errore.setMessaggio("Nessun elemento trovato");
            throw errore;
	
	} // end if (res==null)
        
        // ritorna il risultato
        return res;
    } // end cercaPerNumtel
    
    
    /**
     * insertPersona: aggiunge un elemento alla lista interna
     * Creation date: (25/10/2002 10.42.11)
     * @param pO_persona Rubrica.Persona
     */
    public void insertPersona(Persona p_persona) {
        // casting a Object
        listaPersone.addElement((Object) p_persona);
	System.out.println("Rubrica aggiornata.");
    } // end insertPersona
    
    /**
     * popolaLista: riempie la lista con nomi fissi
     * Creation date: (25/10/2002 11.00.44)
     */
    public void popolaLista() {
	Persona temporaneo;

	temporaneo=new Persona("Simone","Mainini","111111");
	listaPersone.addElement((Object)temporaneo);
	
	temporaneo=new Persona("Giulio","Destri","222222");
	listaPersone.addElement((Object)temporaneo);

	temporaneo=new Persona("Gianluca","Golinelli","333333");
	listaPersone.addElement((Object)temporaneo);

	temporaneo=new Persona("Marco","Solci","444444");
	listaPersone.addElement((Object)temporaneo);

	temporaneo=new Persona("Oscar","Figus","5555555");
	listaPersone.addElement((Object)temporaneo);
	
    } // end popolaLista

    
    /**
     * caricaRubrica: legge la rubrica da un file
     * Creation date: (30/10/2002 16.40.22)
     * @param p_filename java.lang.String
     */
    public void caricaRubrica(String p_filename) {
	Persona temporaneo = null;
	String temp_string;
	

        
        BufferedReader inputFile; 
        String inputLine;
        StringTokenizer tokenizer;
        
        String f_cognome = "";
        String f_nome = "";
        String f_numtel = "";
        
        try {
            // apre il file in lettura
            inputFile = new BufferedReader(new FileReader(p_filename));
        
            // legge il file riga per riga
            inputLine = inputFile.readLine();
            while (inputLine != null) {
                System.out.println(inputLine);
                // imposta il tokenizzatore per inputLine, con "\r \t \n" a fare da separatori
                tokenizer = new StringTokenizer(inputLine,"\t");
                
                //
                if (tokenizer.countTokens() != 3) {
                    System.out.println(
                        "numero di token"+
                        tokenizer.countTokens()+
                        "ERRORE nella riga");
                } else  {
                                   
                    String t_nome = tokenizer.nextToken();
                    StringTokenizer st_nome = new StringTokenizer(t_nome);
                    if (st_nome.countTokens() != 3) {
                        System.out.println(
                        "numero di token"+
                        st_nome.countTokens()+
                        "ERRORE nella riga"); 
                    } else {
                        System.out.println(st_nome.nextToken());
                        System.out.println(st_nome.nextToken());
                        f_nome = st_nome.nextToken();
                        System.out.println(f_nome);
                    }     
                    
                    String t_cognome = tokenizer.nextToken();
                    StringTokenizer st_cognome = new StringTokenizer(t_cognome);
                    if (st_cognome.countTokens() != 3) {
                        System.out.println(
                        "numero di token"+
                        st_cognome.countTokens()+
                        "ERRORE nella riga"); 
                    } else {
                        System.out.println(st_cognome.nextToken());
                        System.out.println(st_cognome.nextToken());
                        f_cognome = st_cognome.nextToken();
                        System.out.println(f_cognome);
                    }
                    
                    String t_numtel = tokenizer.nextToken();
                    StringTokenizer st_numtel = new StringTokenizer(t_numtel);
                    if (st_numtel.countTokens() != 2) {
                        System.out.println(
                        "numero di token"+
                        st_numtel.countTokens()+
                        "ERRORE nella riga"); 
                    } else {
                        System.out.println(st_numtel.nextToken());
                        f_numtel = st_numtel.nextToken();
                        System.out.println(f_numtel);
                    }
                    
                    
                    temporaneo = new Persona(f_nome, f_cognome, f_numtel);
                    listaPersone.addElement((Object)temporaneo);
                }
                  
                inputLine = inputFile.readLine();
            } // end while

            // chiude il file 
            inputFile.close();
            
       
        // gestione delle varie eccezioni possibili con i file
	} catch(FileNotFoundException e) {
		System.err.println("File Not Found!");
	} catch(IOException e) {
		System.err.println("I/Oerr");
	} catch(IllegalArgumentException e) {
		System.err.println ("java FileCopy srcdest");
	} finally { /*
		try {
                    //if (inputFile != null) inputFile.close();
		} catch(IOException e) {
                    System.err.println("I/O err");
		} */
	}
    } // end caricaRubrica

    
    
    /**
     * salvaRubrica: salva la rubrica su file
     * Creation date: (30/10/2002 16.40.22)
     * @param p_filename java.lang.String
     */
    public void salvaRubrica(String p_filename) {
	Persona temporaneo = null;
	String temp_string;
	FileOutputStream fout= null;

	try {
            
            // apre il file in scrittura
            fout = new FileOutputStream(p_filename);
            
            // conta le persone presenti nella lista
            int numpersone = listaPersone.size();
            
            // per ciascuna persona
            for (int i=0;i<numpersone;i++){
                
                // estrae un elemento temporaneo
                temporaneo = (Persona)listaPersone.elementAt(i);
                
                // lo converte in stringa con il metodo apposito
                temp_string=temporaneo.toString();
                
                // trasforma la stringa in un array di byte (compatibile ASCII)
                byte b[]=temp_string.getBytes();
                
                // scrive l'array nel file
	        fout.write(b);
                
                // definisce il fineriga e lo aggiunge al file
	        byte finRiga[] = "\r\n".getBytes();
	        fout.write(finRiga);
                
            } // end for 
        
            // chiude il file
            fout.close();
            
        // gestione delle varie eccezioni possibili con i file
	} catch(FileNotFoundException e) {
		System.err.println("File Not Found!");
	} catch(IOException e) {
		System.err.println("I/Oerr");
	} catch(IllegalArgumentException e) {
		System.err.println ("java FileCopy srcdest");
	} finally {
		try {
			if (fout != null) fout.close();
		} catch(IOException e) {
			System.err.println("I/O err");
		}
	}
    } // end salvaRubrica


} // end class GestoreRubrica
