/*
 * GestoreRubricaLocal.java
 *
 * Created on 20 settembre 2003, 12.57
 * @author Giulio Destri
 */

package rubricaLib;

import java.util.*;
import java.sql.*;
import java.io.*;

import entityLib.Persona;
import exceptionLib.RubricaException;
/**
 *
 */
public class GestoreRubricaLocal {
    
    private Vector listaPersone;
    private int posizioneCorrente;
    
       static Connection dbcon;

    private final static String DB_DRIVERNAME = "sun.jdbc.odbc.JdbcOdbcDriver";
    private final static String DB_URL = "jdbc:odbc:";
    private final static String DB_DS_NAME = "rubrica"; 
    private final static String DB_USERNAME = "";
    private final static String DB_PASSWORD = "";
    
    /** 
     * Creates a new instance of GestoreRubrica 
     * Costruttore, richiama il metodo di connessione al DB
     */
    public GestoreRubricaLocal() {
        listaPersone = new Vector();
     //   inizializzaRubrica();
        posizioneCorrente = 0;
        connectToDB();
        //caricaRubricaDB();
    }
    
    /**
     * connectToDB, si connette al DB usando i 5 parametri definiti come 
     * attributi della classe
     * Creation date: (4/11/2002 11.46.52)
     * 
     */
    public void connectToDB() {

        try {
            // determinazione del driver
	    Class.forName(DB_DRIVERNAME);

            // creazione della connessione
	    dbcon = DriverManager.getConnection(
		DB_URL+DB_DS_NAME, DB_USERNAME, DB_PASSWORD);
            
 	} catch (ClassNotFoundException cnfe) { // class exception: non si trova il driver
	      System.err.println("Errore Fatale --- non possibile caricare il driver "+DB_DRIVERNAME);
	      System.exit(-1); // il programma termina
	} catch (SQLException sqle) { // SQL exception: username o passwd errati
	      System.err.println("Errore Fatale --- non possibile connettere l'utente:"+DB_USERNAME+" al DB "+DB_URL+DB_DS_NAME);
	      //System.exit(-1);
	}

	try {
            // determina informazioni sul database
            DatabaseMetaData dbmd= dbcon.getMetaData();

            // stampa le informazioni
            System.out.println(
                "Connesso a:"+ dbmd.getDatabaseProductName()+
                    	" "+ dbmd.getDatabaseProductVersion()+
		   " ["+DB_DS_NAME+"]\n");

	} catch (SQLException sqle) { // SQL exception: non si hanno info sul DB
	   System.err.println("Errore fatale (2) --- non posso ottenere info sul database");
	   //System.exit(-2);
	} 
	
	System.gc();	// clean up della memoria

    } // end ConnectToDB7
    
    public void setPosizioneCorrente(int p_posizione)  {
        posizioneCorrente= p_posizione;
    }
    
    
    public int getPosizioneCorrente()  {
        return posizioneCorrente;
    }
    
    public int getSize()  {
        return listaPersone.size();
    }    
    
    public Persona cercaPerCognome(java.lang.String p_cognome) {
                
        // Persona da ritornare
	Persona res=null;
        
        // Persona usata per il test di ricerca
	Persona temporaneo;
        
        // calcolo del numero di persone presenti nella lista
	int numPersone=listaPersone.size();
        
        // ricerca interna alla lista
	for (int i=0; i<numPersone;i++) { 
            
            // l'elemento temporaneo e' quello corrente del ciclo
            // deve essere "castizzato" a Persona essendo un Object
            temporaneo=(Persona) listaPersone.elementAt(i);
            
            // se l'elemento ha lo stesso cognome
            if (temporaneo.getCognome().equals(p_cognome)) { 
               
                // viene copiato come risultato
                res=temporaneo; 
                
                // impostiamo la posizione corrnte nella lista
                posizioneCorrente = i;
                
                // e si esce dal ciclo (solo il primo elemento e' trovato)
                break;
            } // end if
	} // end for
        
        // se il risultato e' ancora null
	if (res==null){
            // viene creato un oggetto con campi vuoti
            res = new Persona("","","");
            posizioneCorrente = 999999;
	} // end if (res==null)
        
        // ritorna il risultato
        return res;
        
    } // end cercaPerCognome
    
    public Persona cercaPerNome(java.lang.String p_nome) {
        
        // persona da ritornare
        Persona res=null;
        
        // persona usata per il test di ricerca
        Persona temporaneo;
        
        // calcolo numero pewrsone nella lista
        int numPersone=listaPersone.size();
        
        // ricerca interna alla lista
        for (int i=0; i<numPersone; i++) {
            // l'elemento temporaneo  quello corrente del ciclo
            // deve essere castizzato a persona essendo un object
            temporaneo=(Persona) listaPersone.elementAt(i);
            
            // se l'elemento ha lo stesso cognome
            if (temporaneo.getNome().equals(p_nome)) {
                
                //viene copiato come risultato
                res=temporaneo;
                
                // impostiamo la posizione corrnte nella lista
                posizioneCorrente = i;
                                
                //e si esce dal ciclo
                break;
            }
        }
        
        // se il risultato  ancora null
        if (res==null){
            res= new Persona("","","");
            posizioneCorrente = 999999;
        }
        
        // ritorna il risultato
        
        return res;
    }
    
    public Persona cercaPerNumtel(java.lang.String p_numtel) {
        
        // persona da ritornare
        Persona res=null;
        
        // persona usata per il test di ricerca
        Persona temporaneo;
        
        // calcolo numero pewrsone nella lista
        int numPersone=listaPersone.size();
        
        // ricerca interna alla lista
        for (int i=0; i<numPersone; i++) {
            // l'elemento temporaneo  quello corrente del ciclo
            // deve essere castizzato a persona essendo un object
            temporaneo=(Persona) listaPersone.elementAt(i);
            
            // se l'elemento ha lo stesso cognome
            if (temporaneo.getNumtel().equals(p_numtel)) {
                
                //viene copiato come risultato
                res=temporaneo;
                
                // impostiamo la posizione corrnte nella lista
                posizioneCorrente = i;
                
                //e si esce dal ciclo
                break;
            }
        }
        
        // se il risultato  ancora null
        if (res==null){
            res= new Persona("","","");
            posizioneCorrente = 999999;
        }
        
        // ritorna il risultato
        
        return res;
    }  // end cerca numtel
    
    
    public Persona getFirst() {
        Persona res;
        
        posizioneCorrente = 0;
        
        res = (Persona)listaPersone.get(0);
        return res;
        
    }  // end getFirst
    
    public Persona getLast() {
        Persona res;
        
        posizioneCorrente = listaPersone.size()-1;
        
        res = (Persona)listaPersone.get(posizioneCorrente);
        return res;
        
    }  // end getFirst
    
    public Persona getNext() {
        Persona res;
        
        if (posizioneCorrente < (listaPersone.size()-1)) {
            posizioneCorrente = posizioneCorrente + 1;
        } // end if
        else {
            posizioneCorrente = listaPersone.size()-1;
        } // end else
        
        res = (Persona)listaPersone.get(posizioneCorrente);
        return res;
        
    }  // end getNext
    
    public Persona getPrevious() {
        Persona res;
        
    if (posizioneCorrente > 0) {
            posizioneCorrente = posizioneCorrente - 1;
        } // end if
        else {
            posizioneCorrente = 0;
        } // end else
         
        res = (Persona)listaPersone.get(posizioneCorrente);
        return res;
        
    }  // end getPrevious
    
    // fine delle ricerche
    
   public void inizializzaRubrica() {
        Persona temp;
        
        temp = new Persona("Antonio", "Stringhini", "11111");
        boolean b = listaPersone.add((Object)temp);
         //add(1,(Object)temp);
        
        temp = new Persona("Cesare", "Chiodelli", "22222");
        b = listaPersone.add((Object)temp);
        
        temp = new Persona("Mario", "Saccenti", "33333");
        b = listaPersone.add((Object)temp);
        
    }
    
    public void inserisciNuovo(Persona p_persona) {
        boolean b = listaPersone.add((Object)p_persona);
    }
    
    
    public void inserisciNuovoDB(Persona p_persona) {
        
        String totalQuery = "INSERT into elenco values (?,?,?) ";
        
	try {
		// crea lo statement
		PreparedStatement pstmt = dbcon.prepareStatement(totalQuery);
                
                // inserisce l'argomento, con i wildcard del DB agli estremi 
                // (ricerca per sottostringa)
		pstmt.setString(1,p_persona.getNome());
                pstmt.setString(2,p_persona.getCognome());
                pstmt.setString(3,p_persona.getNumtel());
		// applica la query ed ottiene il resultset
		pstmt.executeUpdate ();
                System.out.println("Inserimento Esegeguito Correttamente");
        
                } catch (SQLException sqle) { // SQL exception
                  System.err.println("Errore Fatale --- non possibile inserire:"+DB_URL+DB_DS_NAME);
                // System.exit(-3);
                }        
	
        
       
    } // end inseriscinuovoDB


    public void CancellaDB(Persona p_persona) {
        
        String totalQuery = "DELETE from elenco WHERE (cognome=?) and (nome=?) and (numtel=?) ";
        
	try {
		// crea lo statement
		PreparedStatement pstmt = dbcon.prepareStatement(totalQuery);
                
                // inserisce l'argomento, con i wildcard del DB agli estremi 
                // (ricerca per sottostringa)
		pstmt.setString(1,p_persona.getCognome());
                pstmt.setString(2,p_persona.getNome());
                pstmt.setString(3,p_persona.getNumtel());
		// applica la query ed ottiene il resultset
		pstmt.executeUpdate ();
                System.out.println("Inserimento Esegeguito Correttamente");
        
                } catch (SQLException sqle) { // SQL exception
                  System.err.println("Errore Fatale --- non possibile inserire:"+DB_URL+DB_DS_NAME);
                // System.exit(-3);
                }        
	
        
       
    } // end inseriscinuovoDB
    
    
public void RimpiazzaDB(Persona p_persona_valore, int posizione_chiave) {
        
      String totalQuery = "UPDATE elenco set Nome=?,Cognome=?,Numtel=? WHERE (nome=?) and (cognome=?) and (numtel=?)";
      Persona persona_chiave;
              
      persona_chiave =  (Persona) listaPersone.elementAt(posizione_chiave);
      
      
      try {
		// crea lo statement
		PreparedStatement pstmt = dbcon.prepareStatement(totalQuery);
                
                // inserisce l'argomento, con i wildcard del DB agli estremi 
                // (ricerca per sottostringa)
		pstmt.setString(1,p_persona_valore.getNome());
                pstmt.setString(2,p_persona_valore.getCognome());
                pstmt.setString(3,p_persona_valore.getNumtel());
                
                // inserisce l'argomento, con i wildcard del DB agli estremi 
                // (ricerca per sottostringa)
		pstmt.setString(4,persona_chiave.getNome());
                pstmt.setString(5,persona_chiave.getCognome());
                pstmt.setString(6,persona_chiave.getNumtel());
                
		// applica la query ed ottiene il resultset
		pstmt.executeUpdate ();
                System.out.println("Rimpiazzamento Esegeguito Correttamente");
        
                } catch (SQLException sqle) { // SQL exception
                  System.err.println("Errore Fatale --- non possibile aggiornamento:"+DB_URL+DB_DS_NAME);
                // System.exit(-3);
                }        
	
        
       
    } // end rimpiazzaDB    
    
    public void cancella(int p_posizione) {
        Persona temporaneo;
        
        temporaneo = (Persona) listaPersone.remove(p_posizione);
        posizioneCorrente = 0;
        
    }

    public void rimpiazza(Persona p_persona, int p_posizione) {
        Persona temporaneo;
        
        temporaneo = (Persona) listaPersone.remove(p_posizione);
        posizioneCorrente = p_posizione;
        listaPersone.insertElementAt((Object)p_persona,p_posizione);
        
    }
    
    public void caricaRubrica(String p_filename) {
	Persona temporaneo = null;
	String temp_string;
	
        BufferedReader inputFile; 
        String inputLine;
        StringTokenizer tokenizer;
        
        String f_cognome = "";
        String f_nome = "";
        String f_numtel = "";
        
        try {
            // apre il file in lettura
            inputFile = new BufferedReader(new FileReader(p_filename));
        
            // legge il file riga per riga
            inputLine = inputFile.readLine();
            while (inputLine != null) {
                System.out.println(inputLine);
                // imposta il tokenizzatore per inputLine, con "\r \t \n" a fare da separatori
                tokenizer = new StringTokenizer(inputLine,";");
                
                //
                if (tokenizer.countTokens() != 3) {
                    System.out.println(
                        "numero di token"+
                        tokenizer.countTokens()+
                        "ERRORE nella riga");
                } else  {
                    f_cognome = tokenizer.nextToken();
                    f_nome = tokenizer.nextToken();
                    f_numtel = tokenizer.nextToken();
                                 
                    
                    temporaneo = new Persona(f_nome, f_cognome, f_numtel);
                    listaPersone.addElement((Object)temporaneo);
                }
                  
                inputLine = inputFile.readLine();
            } // end while

            // chiude il file 
            inputFile.close();
            
       
        // gestione delle varie eccezioni possibili con i file
	} catch(FileNotFoundException e) {
		System.err.println("File Not Found!");
	} catch(IOException e) {
		System.err.println("I/Oerr");
	} catch(IllegalArgumentException e) {
		System.err.println ("java FileCopy srcdest");
	} finally { /*
		try {
                    //if (inputFile != null) inputFile.close();
		} catch(IOException e) {
                    System.err.println("I/O err");
		} */
	}
    } // end caricaRubrica
        /**
     * salvaRubrica: salva la rubrica su file
     * Creation date: (30/10/2002 16.40.22)
     * @param p_filename java.lang.String
     */
    public void salvaRubrica(String p_filename) {
	Persona temporaneo = null;
	String temp_string;
	FileOutputStream fout= null;

	try {
            
            // apre il file in scrittura
            fout = new FileOutputStream(p_filename);
            
            // conta le persone presenti nella lista
            int numpersone = listaPersone.size();
            
            // per ciascuna persona
            for (int i=0;i<numpersone;i++){
                
                // estrae un elemento temporaneo
                temporaneo = (Persona)listaPersone.elementAt(i);
                
                // lo converte in stringa con il metodo apposito
                temp_string=temporaneo.getCognome()+"\t"+temporaneo.getNome()+"\t"+temporaneo.getNumtel();
                
                // trasforma la stringa in un array di byte (compatibile ASCII)
                byte b[]=temp_string.getBytes();
                
                // scrive l'array nel file
	        fout.write(b);
                
                // definisce il fineriga e lo aggiunge al file
	        byte finRiga[] = "\r\n".getBytes();
	        fout.write(finRiga);
                
            } // end for 
        
            // chiude il file
            fout.close();
            
        // gestione delle varie eccezioni possibili con i file
	} catch(FileNotFoundException e) {
		System.err.println("File Not Found!");
	} catch(IOException e) {
		System.err.println("I/Oerr");
	} catch(IllegalArgumentException e) {
		System.err.println ("java FileCopy srcdest");
	} finally {
		try {
			if (fout != null) fout.close();
		} catch(IOException e) {
			System.err.println("I/O err");
		}
	}
    } // end salvaRubrica
    
    
    public void caricaRubricaDB() {
        Persona temporaneo = null;
        String totalQuery = "SELECT Nome, Cognome, Numtel from elenco";
        ResultSet rs;
	int numCols;
	int numRows;
	int row = 1;

	try {
		// crea lo statement
		PreparedStatement pstmt = dbcon.prepareStatement(totalQuery);
                
                // inserisce l'argomento, con i wildcard del DB agli estremi 
                // (ricerca per sottostringa)
		//pstmt.setString(1,"");

		// applica la query ed ottiene il resultset
		rs = pstmt.executeQuery ();
                
                
		// conta le colonne presenti
		numCols = rs.getMetaData().getColumnCount();

		// stampa i nomi delle colonne presenti su stdout
		for (int col=1; col<=numCols; col++) {
                    System.out.print(rs.getMetaData().getColumnName(col) + " | "); 	
		}
		System.out.println("|");
                
                                
                //ricerca per tutto il resultset
		// legge tutte le righe del ResultSet
		while (rs.next()) { 	
                    // costruisce l'oggetto Persona contenente i dati dell'ultimo record trovato
                    temporaneo = new Persona(rs.getString(1),rs.getString(2),rs.getString(3));
                    /*
                    for (int col=1; col<=numCols; col++) { 	
			  String string = rs.getString (col);
	 	 	  System.out.print(string + " | "); 
			}
	 		System.out.println("");
	 		row ++;
                     */
                    listaPersone.add(temporaneo);
		} // end while
                 
		
	} catch (SQLException sqle) { // SQL exception
	      System.err.println("Errore Fatale --- non possibile interrogare il DB:"+DB_URL+DB_DS_NAME);
	      // System.exit(-3);
	}
        
        // se il risultato e' ancora null
	if (temporaneo==null){
            // viene lanciata un'eccezione
            System.err.println("Errore");
	} // end if (res==null)
        
        
    } // end caricaRubricaDB
    
    public void cercaPerNomeDB(String p_nome) throws RubricaException {
        Persona temporaneo = null;
        String totalQuery = "SELECT Nome, Cognome, Numtel from elenco where Nome = ?";
        ResultSet rs;
	int numCols;
	int numRows;
	int row = 1;

	try {
		// crea lo statement
		PreparedStatement pstmt = dbcon.prepareStatement(totalQuery);
                
                // inserisce l'argomento, con i wildcard del DB agli estremi 
                // (ricerca per sottostringa)
		pstmt.setString(1,p_nome);

		// applica la query ed ottiene il resultset
		rs = pstmt.executeQuery ();
                
                
		// conta le colonne presenti
		numCols = rs.getMetaData().getColumnCount();

		// stampa i nomi delle colonne presenti su stdout
		for (int col=1; col<=numCols; col++) {
                    System.out.print(rs.getMetaData().getColumnName(col) + " | "); 	
		}
		System.out.println("|");
                
                                
                //ricerca per tutto il resultset
		// legge tutte le righe del ResultSet
		while (rs.next()) { 	
                    // costruisce l'oggetto Persona contenente i dati dell'ultimo record trovato
                    temporaneo = new Persona(rs.getString(1),rs.getString(2),rs.getString(3));
                    /*
                    for (int col=1; col<=numCols; col++) { 	
			  String string = rs.getString (col);
	 	 	  System.out.print(string + " | "); 
			}
	 		System.out.println("");
	 		row ++;
                     */
                    listaPersone.add(temporaneo);
		} // end while
                 
		
	} catch (SQLException sqle) { // SQL exception
	      System.err.println("Errore Fatale --- non possibile interrogare il DB:"+DB_URL+DB_DS_NAME);
	      // System.exit(-3);
	}
        
        // se il risultato e' ancora null
	if (temporaneo==null){
            // viene lanciata un'eccezione
            System.err.println("Errore");
            RubricaException eccezione;
            eccezione= new RubricaException();
            eccezione.setMessaggio("Non ho trovato nulla!");
            throw eccezione;
	} // end if (res==null)
        
        
    } // end cercaPerNomeDB
    
    public void cercaPerCognomeDB(String p_cognome)throws RubricaException {
        Persona temporaneo = null;
        String totalQuery = "SELECT Nome, Cognome, Numtel from elenco where Cognome = ?";
        ResultSet rs;
	int numCols;
	int numRows;
	int row = 1;

	try {
		// crea lo statement
		PreparedStatement pstmt = dbcon.prepareStatement(totalQuery);
                
                // inserisce l'argomento, con i wildcard del DB agli estremi 
                // (ricerca per sottostringa)
		pstmt.setString(1,p_cognome);

		// applica la query ed ottiene il resultset
		rs = pstmt.executeQuery ();
                
                
		// conta le colonne presenti
		numCols = rs.getMetaData().getColumnCount();

		// stampa i nomi delle colonne presenti su stdout
		for (int col=1; col<=numCols; col++) {
                    System.out.print(rs.getMetaData().getColumnName(col) + " | "); 	
		}
		System.out.println("|");
                
                                
                //ricerca per tutto il resultset
		// legge tutte le righe del ResultSet
		while (rs.next()) { 	
                    // costruisce l'oggetto Persona contenente i dati dell'ultimo record trovato
                    temporaneo = new Persona(rs.getString(1),rs.getString(2),rs.getString(3));
                    /*
                    for (int col=1; col<=numCols; col++) { 	
			  String string = rs.getString (col);
	 	 	  System.out.print(string + " | "); 
			}
	 		System.out.println("");
	 		row ++;
                     */
                    listaPersone.add(temporaneo);
		} // end while
                 
		
	} catch (SQLException sqle) { // SQL exception
	      System.err.println("Errore Fatale --- non possibile interrogare il DB:"+DB_URL+DB_DS_NAME);
	      // System.exit(-3);
	}
        
        // se il risultato e' ancora null
	if (temporaneo==null){
            // viene lanciata un'eccezione
            System.err.println("Errore");
            RubricaException eccezione;
            eccezione= new RubricaException();
            eccezione.setMessaggio("Non ho trovato nulla!");
            throw eccezione;
	} // end if (res==null)
        
        
    } // end cercaPerNomeDB
    
    public void cercaPerNumTelDB(String p_numtel) throws RubricaException {
        Persona temporaneo = null;
        String totalQuery = "SELECT Nome, Cognome, Numtel from elenco where Numtel = ?";
        ResultSet rs;
	int numCols;
	int numRows;
	int row = 1;

	try {
		// crea lo statement
		PreparedStatement pstmt = dbcon.prepareStatement(totalQuery);
                
                // inserisce l'argomento, con i wildcard del DB agli estremi 
                // (ricerca per sottostringa)
		pstmt.setString(1,p_numtel);

		// applica la query ed ottiene il resultset
		rs = pstmt.executeQuery ();
                
                
		// conta le colonne presenti
		numCols = rs.getMetaData().getColumnCount();

		// stampa i nomi delle colonne presenti su stdout
		for (int col=1; col<=numCols; col++) {
                    System.out.print(rs.getMetaData().getColumnName(col) + " | "); 	
		}
		System.out.println("|");
                
                                
                //ricerca per tutto il resultset
		// legge tutte le righe del ResultSet
		while (rs.next()) { 	
                    // costruisce l'oggetto Persona contenente i dati dell'ultimo record trovato
                    temporaneo = new Persona(rs.getString(1),rs.getString(2),rs.getString(3));
                    /*
                    for (int col=1; col<=numCols; col++) { 	
			  String string = rs.getString (col);
	 	 	  System.out.print(string + " | "); 
			}
	 		System.out.println("");
	 		row ++;
                     */
                    listaPersone.add(temporaneo);
		} // end while
                 
		
	} catch (SQLException sqle) { // SQL exception
	      System.err.println("Errore Fatale --- non possibile interrogare il DB:"+DB_URL+DB_DS_NAME);
	      // System.exit(-3);
	}
        
        // se il risultato e' ancora null
	if (temporaneo==null){
            // viene lanciata un'eccezione
            System.err.println("Errore");
            RubricaException eccezione;
            eccezione= new RubricaException();
            eccezione.setMessaggio("Non ho trovato nulla!");
            throw eccezione;
	} // end if (res==null)
        
        
    } // end cercaPerNomeDB    
    
        public void salvaRubricaDB(String p_filename) {
	Persona temporaneo = null;
	String temp_string;
	FileOutputStream fout= null;

	try {
            
            // apre il file in scrittura
            fout = new FileOutputStream(p_filename);
            
            // conta le persone presenti nella lista
            int numpersone = listaPersone.size();
            
            // per ciascuna persona
            for (int i=0;i<numpersone;i++){
                
                // estrae un elemento temporaneo
                temporaneo = (Persona)listaPersone.elementAt(i);
                
                // lo converte in stringa con il metodo apposito
                temp_string=temporaneo.getCognome()+";"+temporaneo.getNome()+";"+temporaneo.getNumtel();
                
                // trasforma la stringa in un array di byte (compatibile ASCII)
                byte b[]=temp_string.getBytes();
                
                // scrive l'array nel file
	        fout.write(b);
                
                // definisce il fineriga e lo aggiunge al file
	        byte finRiga[] = ";".getBytes();
	        fout.write(finRiga);
                
            } // end for 
        
            // chiude il file
            fout.close();
            
        // gestione delle varie eccezioni possibili con i file
	} catch(FileNotFoundException e) {
		System.err.println("File Not Found!");
	} catch(IOException e) {
		System.err.println("I/Oerr");
	} catch(IllegalArgumentException e) {
		System.err.println ("java FileCopy srcdest");
	} finally {
		try {
			if (fout != null) fout.close();
		} catch(IOException e) {
			System.err.println("I/O err");
		}
	}
    } // end salvaRubrica

  
} // end class GestoreRubricaLocal
