/*
 * SuccessivoServlet.java
 *
 * Created on 19 luglio 2004, 18.11
 */

package sessionHandling;

import java.io.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

/**
 *
 * @author  gdestri
 * @version
 */
public class SuccessivoServlet extends HttpServlet {
    
    /** Initializes the servlet.
     */
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        
    }
    
    /** Destroys the servlet.
     */
    public void destroy() {
        
    }
    
    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        
        // TODO output your page here
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Successivo Servlet</title>");
        out.println("</head>");
        out.println("<body>");
        
        // abilita l'uso della sessione
        HttpSession session = request.getSession(true);
        
        // estrae l'utenteCorrente dalla sessione
        UtenteWeb utenteCorrente = (UtenteWeb)session.getAttribute("utenteCorrente");
        
        // lo verifica
        if (utenteCorrente != null) {
    
            // verifica che la sessione di appartenenza abbia lo stesso ID contenuto nell'oggetto
            String currentSessionID = session.getId();

            // estrae l'ID di sessione dall'oggetto utenteCorrente, 
            // associato alla sessione dalla pagina precedente
            String origSessionID = utenteCorrente.getSessionID();

            // se tale ID e' non nullo ed uguale all'altra sessione tutto OK  
            if ((origSessionID != null) && (currentSessionID.equals(origSessionID))) {
                out.println("Esatto: Sessione riconosciuta correttamente!<BR>");
                out.println("I dati della sessione sono:");
                out.println(utenteCorrente.toWebString());
                out.println("<HR>");
                out.println("Premere <A href=\"/EsempiWebIS2005/LogoutServlet\"> Qui </A> per uscire");
            } 
            else {
                out.println("Errato!<BR>");
            }
        }
        else {
            out.println("Oggetto NULLO: accesso vietato");
        }
                       
        out.println("</body>");
        out.println("</html>");
         
        out.close();
    }
    
    /** Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Returns a short description of the servlet.
     */
    public String getServletInfo() {
        return "Short description";
    }
    
}
