/*
 * SessionManager.java
 *
 * Created on 11 dicembre 2005, 17.27
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package sessionMgrLib;

import java.io.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

import java.util.*;

/**
 *
 * @author gdestri
 */
public class SessionManager {
    
    /** Creates a new instance of SessionManager */
    public SessionManager() {
    }

    public HttpSession createSession(HttpServletRequest p_request, String p_username) {
        // abilita l'uso della sessione
        HttpSession session = p_request.getSession(true);

        // registra il timestamp della creazione della sessione
        Date created = new Date(session.getCreationTime());
        Date accessed = new Date(session.getLastAccessedTime());
        
        // crea un utenteWeb
        WebSessionData currentUser = new WebSessionData(p_username, 
                                                  created.toString(), 
                                                  accessed.toString(), 
                                                  session.getId());

        // lo aggancia alla sessione
        session.setAttribute("utenteCorrente", currentUser);
       
        // restituisce la sessione
        return session;
    } // end method createSession

    public boolean validateSession(HttpServletRequest p_request) {
        boolean res = false;
        // abilita l'uso della sessione
        HttpSession session = p_request.getSession(true);
        
        // estrae l'utenteCorrente dalla sessione
        WebSessionData utenteCorrente = (WebSessionData)session.getAttribute("utenteCorrente");
        
        // lo verifica
        if (utenteCorrente != null) {
    
            // verifica che la sessione di appartenenza abbia lo stesso ID contenuto nell'oggetto
            String currentSessionID = session.getId();

            // estrae l'ID di sessione dall'oggetto utenteCorrente, 
            // associato alla sessione dalla pagina precedente
            String origSessionID = utenteCorrente.getSessionID();

            // se tale ID e' non nullo ed uguale all'altra sessione tutto OK  
            if ((origSessionID != null) && (currentSessionID.equals(origSessionID))) {
                res = true;
            } 
            else {
                res = false;
            }
        }
        else {
            res = false;
        }

        return res;
    } // end method validateSession
    
    public WebSessionData getCurrentSessionData(HttpServletRequest p_request) {
        // crea l'oggetto vuoto da tornare in caso che la sessione non sia valida
        WebSessionData res = new WebSessionData();
        
        if (validateSession(p_request)) {
            // abilita l'uso della sessione
            HttpSession session = p_request.getSession(true);
        
            // estrae l'utenteCorrente dalla sessione
            res = (WebSessionData)session.getAttribute("utenteCorrente");          
        } // end if
        return res;
    } // end method getCurrentSessionData
    
} // end class SessionManager
